//30.03.2019
//by Reptiloid software

/*
 
Данный скетч реализует ручную независимую регулировку мощности для каждого диммера
с помощью соответствующего потенциометра на аналоговых пинах
(рекомендуемы номинал 1-100К)

Так же можно использовать для теста одиночного диммера

Подробное описание работы и синтаксиса библиотеки можете 
посмотреть в примере AC_DIMMER_FADE

Демонстрацию работы библиотеки на тестовом стенде и схему можно посмотреть здесь:
https://www.youtube.com/watch?v=9fhkJQIRmEA

*/


#include <AC_Dimmer.h>

#define Dimmer_1 0
#define Dimmer_2 1
#define Dimmer_3 2


void setup()
{
  Dimmer_init_begin();
    
   Dimmer_pin_assign(Dimmer_1, 3);  
   Dimmer_pin_assign(Dimmer_2, A3);
   Dimmer_pin_assign(Dimmer_3, A2);
    
  Dimmer_init_end();
}

int adc_read;

void loop() 
{     
      adc_read = analogRead(A4)/4;
      Dimm_value(Dimmer_1,  adc_read);  // потенциометры на пинах А4, А5, А6
      adc_read = analogRead(A5)/4;
      Dimm_value(Dimmer_2,  adc_read);  // для ручной регулировки мощности 
      adc_read = analogRead(A6)/4;
      Dimm_value(Dimmer_3,  adc_read);  // на каждый диммер
      
      delay(50);
}
